"use strict";
function isNumeric(n) {
    return !isNaN(parseFloat(n)) && isFinite(n);
}
exports.isNumeric = isNumeric;
function _c(val, type) {
    switch (type) {
        case Array:
        case 'Array':
            return Array.isArray(val);
        case Date:
        case 'Date':
            return val !== undefined && val instanceof Date;
        case Object:
        case 'Object':
            return val !== null && typeof val === 'object' && !_c(val, Date) && !_c(val, Array) && !_c(val, Error);
        case String:
        case 'String':
            return typeof val === 'string' && !isNumeric(val);
        case Number:
        case 'Number':
            return isNumeric(val);
        case Function:
        case 'Function':
            return (val !== null && typeof val === 'function');
        case Boolean:
        case 'Boolean':
            return typeof val === 'boolean';
        case Number:
        case 'Number':
            return isNumeric(val);
        case 'undefined':
        case undefined:
        case 'Undefined':
            return val === undefined;
        case null:
            return val === null;
        case Error:
        case 'Error':
            return val instanceof Error;
        case 'any':
            return (val !== null && val !== undefined) || isNumeric(val);
        default:
            return val !== undefined && val.constructor === type;
    }
}
function check(val, type) {
    if (_c(type, Array)) {
        for (var _i = 0, type_1 = type; _i < type_1.length; _i++) {
            var sType = type_1[_i];
            if (_c(val, sType)) {
                return true;
            }
        }
        return false;
    }
    return _c(val, type);
}
exports.check = check;
